from typing import Any

from sqlalchemy import create_engine
from sqlalchemy.ext.compiler import compiles
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy.orm import sessionmaker
from sqlalchemy.schema import CreateColumn

from .config import SQLALCHEMY_DATABASE_URI


@compiles(CreateColumn, "postgresql")
def use_identity(element: Any, compiler: Any, **kw: dict) -> str:
    text = compiler.visit_create_column(element, **kw)
    return text.replace("SERIAL", "INT GENERATED BY DEFAULT AS IDENTITY")


Base = declarative_base()

engine = create_engine(SQLALCHEMY_DATABASE_URI)
SessionLocal = sessionmaker(bind=engine)
